//+------------------------------------------------------------------+
//|                                                      $Machki.mq4 |
//|                                                             Alex |
//|                                                   al53@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Alex"
#property link      "al53@yandex.ru"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
extern    int     OpenPosition=3 ;//        
extern    int     Fast =10;      //    
extern    int     Small  =5;     //     Small+ Fast
extern    double  Mnogitel=10 ;  //    ATR      
extern    int     Totalanalis=30 ;// -    
double   Analis[1] ; //
int       CountPosition ;
//=====================================================================================
int init()
  {
   ArrayResize(Analis,Totalanalis)  ;
   if (GlobalVariableCheck("Grafika")== false)  
       GlobalVariableSet( "Grafika", 0)  ;
   return(0);
  }
//===================================================================================
int deinit()
  {
   GlobalVariableDel( "Grafika")  ;
   return(0);
  }
//=============================================================================
void Open_Short_Position (int mgoppos,double lotsoppos)
   {
//       
      double TP,SL,aaa,bbb ;
      aaa=iATR(Symbol(),0,Fast,0)*Mnogitel ;
      TP=NormalizeDouble(Bid-aaa,Digits) ;
      SL=NormalizeDouble(Bid+aaa,Digits) ;
      OrderSend(Symbol(),OP_SELL,lotsoppos,Bid,100,SL,TP,0,mgoppos,0,Blue);
     return(0) ;
   }
//===============================================================================
void Open_Long_Position (int mgoppos,double lotsoppos)
   {
//       
      double TP,SL,aaa ,bbb;
      aaa=iATR(Symbol(),0,Fast,0)*Mnogitel ;
      TP=NormalizeDouble(Bid+aaa,Digits) ;
      SL=NormalizeDouble(Bid-aaa,Digits) ;
      OrderSend(Symbol(),OP_BUY,lotsoppos,Ask,100,SL,TP,0,mgoppos,0,Red);
    return(0) ;
   }
//==============================================================================
int ChPos(int type_H_L,int Magic) 
{
//  -    
   int i;
   int col;
   int count=0 ;
   for( i=0; i < OrdersTotal(); i++)         
   {
      if(OrderSelect(i,SELECT_BY_POS)==true) 
       {                                   
           if(OrderType()==OP_BUY && type_H_L==OP_BUY && OrderMagicNumber()==Magic){count++;}
           if(OrderType()==OP_SELL && type_H_L==OP_SELL && OrderMagicNumber()==Magic){count++;}
       }
    }   
return(count);

}
//==============================================================================
int OrdersHistoryTotal_Opbuy_Opsell(int Magic)
   {
      int total ,count;
//   -    ,      
//
      total=OrdersHistoryTotal()  ;
      for (int i=0 ;i < total ; i++) 
         {
            OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)  ;
            if ((OrderType()==OP_BUY || OrderType()==OP_SELL) && OrderMagicNumber()==Magic)
                     count++;
         }
   return(count) ;
   }
//===============================================================================
double AnalisEquty(int magic_analis,int position_analis)
   {
//       Totalanalis    1.   
//   Totalanalis   1,1+2,1+2+3,    2.    
//    2.    (    
//  ) 3.       -  (Totalanalis)   
//     ,     .
   double OpenPosition,ClosePosition,Disp,LinearReg,Profit;
   int x ,i,j,total_history ;
   double   Summ_x,Summ_y,Summ_xy,Summ_x_2,b,CumProfit,a,Sredn_y ,AC;
   double  Pi=3.14159265358979 ,Deviation,StdDeviation;
    for (i=OrdersHistoryTotal()-1 ; i >= 0; i--)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)  ;
            if ((OrderType()==OP_BUY || OrderType()==OP_SELL) && OrderMagicNumber()==magic_analis)
              {
                if( OrderType() ==OP_BUY )
                 { Profit=(OrderClosePrice()-OrderOpenPrice())*OrderLots()*AccountLeverage( ) ;}//     
                if( OrderType() ==OP_SELL )   
                 { Profit=(OrderOpenPrice()-OrderClosePrice())*OrderLots()*AccountLeverage( ) ;}//     
                  Analis[position_analis-j]=Profit ;  //       .      .
                 if (j == position_analis)
                        {  break  ;}
                 j++ ;
              }
      }
     for (i=1; i < position_analis ;i++)
     {
      CumProfit=Analis[i] ;
      Analis[i]=CumProfit+Analis[i-1];
     }
         Print("C  ",position_analis,"   ",Analis[position_analis-1]) ;
         for ( x=0 ;x < Totalanalis  ; x++)
            {  
               Summ_x=Summ_x+x;  
               Summ_y=Summ_y+Analis[x];   
               Summ_xy=Summ_xy+x*Analis[x]; 
               Summ_x_2=Summ_x_2+MathPow(x,2); 
            }
            b=((Totalanalis-1)*Summ_xy-Summ_x*Summ_y)/((position_analis-1)*Summ_x_2-MathPow(Summ_x,2));
            a=(Summ_y-b*Summ_x)/(position_analis-1);
   for (  x=0 ;x < position_analis  ; x++) 
      {
         if ( b >0 )
            {
               AC= MathAbs(Analis[x]-(b*x+a))*MathSin(Pi/2-MathArctan(b)) ;
            }
          if ( b<0 )
            {
               AC=MathAbs(Analis[x]-(b*x+a))*MathSin(MathArctan(b)-Pi/2) ;
            }
        Deviation=Deviation+ MathPow(AC,2) ;  
      }
      StdDeviation=MathSqrt(Deviation/position_analis);
      return((b/position_analis)/StdDeviation*10000) ;
   }
//======================================================================================================   
    
int start()
  {
  double FastEma,SmallEma ;
  int    ccc ;
  static int aaa ;
  static double bbb ;
//         
//      
   FastEma=iMA(Symbol(),0,40,0,MODE_SMA,PRICE_OPEN,Fast) ;
   SmallEma=iMA(Symbol(),0,10,0,MODE_SMA,PRICE_OPEN,Small+Fast) ;
   if (FastEma > SmallEma  &&  ChPos(OP_BUY,1111) < OpenPosition)
      {
         Open_Long_Position(1111,0.1)  ; 
      }
   if (FastEma < SmallEma  &&  ChPos(OP_SELL,1111) < OpenPosition)
      {
         Open_Short_Position (1111,0.1) ;
      }
   if ( aaa == OrdersHistoryTotal_Opbuy_Opsell(1111) )
               return(0) ;
        aaa=OrdersHistoryTotal_Opbuy_Opsell(1111);
        if (aaa > Totalanalis)
        {
            bbb=AnalisEquty(1111,Totalanalis) ;
        }
    if (bbb <= 0 )
         return (0) ;
         if (FastEma > SmallEma  &&  ChPos(OP_BUY,2222) < OpenPosition)
                  {  Open_Long_Position(2222,10)  ;  }
         if (FastEma < SmallEma  &&  ChPos(OP_BUY,2222) < OpenPosition)
                  {  Open_Short_Position (2222,10) ;  }
        
       // Print ("    = ",bbb,"  -   = ",aaa) ;
        GlobalVariableSet( "Grafika", bbb) ;
       //GlobalVariableSet( "Grafika", AccountBalance()) ;
   return(0);
  }
//+------------------------------------------------------------------+